package prjaoadlwithcm.actions;

import java.util.ArrayList;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.ViewerNotification;
import org.eclipse.ui.IViewReference;
import org.eclipse.ui.PlatformUI;

import prjaoadlwithcm.views.AOADLwithCMErrorsListing;

import aoadl.AoadlPackage;
import aoadl.Attachment;
import aoadl.BoundedRole;
import aoadl.Component;
import aoadl.ComponentInstance;
import aoadl.Connector;
import aoadl.ConnectorInstance;
import aoadl.Interface;
import aoadl.InterfaceCompositeComponent;
import aoadl.impl.AttachmentImpl;
import aoadl.impl.ComponentImpl;
import aoadl.impl.ConnectorImpl;
import aoadl.impl.InterfaceImpl;

public class AvaliableChanges implements INotifyChangedListener{
	
	public void validateConnector(Object obj) {
		ConnectorImpl cnnImp = (ConnectorImpl)obj;
		
		ArrayList<BoundedRole> listClassifiers = new ArrayList<BoundedRole>();
		ArrayList<String> errors = new ArrayList<String>();
		boolean isRigth;

		Object o = cnnImp.getClassifier() ;
		
		if(cnnImp.getClassifier() == null){
			errors.add("Set a Classifier for Connector " + cnnImp.getName());
		}else{

			for (int i = 0; i < cnnImp.getClassifier().getConnector().getRole().size(); i++) {
				listClassifiers.add(cnnImp.getClassifier().getConnector().getRole().get(i));
			}
				
			//Assertion
			if(cnnImp.getRole().size() == 0) return;
			
			
			for (int i = 0; i < cnnImp.getRole().size(); i++) {
				isRigth = false;
				if(((BoundedRole)cnnImp.getRole().get(i)).getInterfaceRole() == null || 
						((BoundedRole)cnnImp.getRole().get(i)).getInterfaceRole().getClassifier() == null){
					isRigth = false;
					errors.add("Error in classification of Interface " + cnnImp.getRole().get(i).getName() + " in Connector " + cnnImp.getName());
					break;
				} 
				for (int j = 0; j < listClassifiers.size(); j++) {
					if(((BoundedRole)cnnImp.getRole().get(i)).getInterfaceRole().getClassifier().getName()
							.equals(listClassifiers.get(j).getInterfaceRole().getName())){
						isRigth = true;
						break;
					}
				}
				if(!isRigth){
					errors.add("Error in classification of Interface Role " + cnnImp.getRole().get(i).getName() + " in Connector " + cnnImp.getName());
				}
			}
		}
		printErrors(errors);
	}
	
	public void printErrors(ArrayList<String> listErrors){
		String id_ = "prjaoadlwithcm.views.AOADLwithCMErrorsListing";
		
		IViewReference viewReferences[] = PlatformUI.getWorkbench()
		.getActiveWorkbenchWindow().getActivePage().getViewReferences();
		for (int i = 0; i < viewReferences.length; i++) {
			if (id_.equals(viewReferences[i].getId())) {
				for(String str : listErrors){
					//AOADLDiagramEditorPlugin.getInstance().logError(str);
					((AOADLwithCMErrorsListing)viewReferences[i].getPart(false)).addError(str);
				}
			}
		}
	}
	
	public void validateComponent(Object obj) {
		ComponentImpl compImp = (ComponentImpl)obj;
		
		ArrayList<InterfaceCompositeComponent> listClassifiers = new ArrayList<InterfaceCompositeComponent>();
		ArrayList<String> errors = new ArrayList<String>();
		boolean isRigth;

		
		if(compImp.getClassifier().size() == 0){
			errors.add("Set a Classifier for Component " + compImp.getName());
		}else{
			
		
			for (int i = 0; i < compImp.getClassifier().size(); i++) {
				ComponentInstance comp = compImp.getClassifier().get(i);
				for (int j = 0; j < comp.getComponent().getInterface().size(); j++) {
					listClassifiers.add(comp.getComponent().getInterface().get(i));
				}
			}
				
			//Assertion
			if(compImp.getInterface().size() == 0) return;
			
			
			for (int i = 0; i < compImp.getInterface().size(); i++) {
				isRigth = false;
				if(((InterfaceCompositeComponent)compImp.getInterface().get(i)).getInterfaceRole() == null || 
						((InterfaceCompositeComponent)compImp.getInterface().get(i)).getInterfaceRole().getClassifier() == null){
					isRigth = false;
					errors.add("Error in classification of Interface " + compImp.getInterface().get(i).getPortName() + " in Component " + compImp.getName());
					break;
				} 
				for (int j = 0; j < listClassifiers.size(); j++) {
					if(((InterfaceCompositeComponent)compImp.getInterface().get(i)).getInterfaceRole().getClassifier().getName()
							.equals(listClassifiers.get(j).getInterfaceRole().getName())){
						isRigth = true;
						break;
					}
				}
				if(!isRigth){
					errors.add("Error in classification of Interface " + compImp.getInterface().get(i).getPortName() + " in Component " + compImp.getName());
				}
			}
		}
		
		printErrors(errors);
	}

	public void validateInterface(Object obj) {
		InterfaceImpl interImp = (InterfaceImpl)obj;
		
		ArrayList<InterfaceImpl> listClassifiers = new ArrayList<InterfaceImpl>();
		ArrayList<String> errors = new ArrayList<String>();
		boolean isRigth;

		
		if(interImp.getClassifier() == null){
			errors.add("Set a Classifier for Interface " + interImp.getName());
		}
		
		printErrors(errors);
	}
	
	public void validateAttachment(Object obj, int notif) {
		AttachmentImpl attImp = (AttachmentImpl)obj;
		ArrayList<String> errors = new ArrayList<String>();
		boolean isRigth;
		
		
		switch (notif) {
		case AoadlPackage.ATTACHMENT__PROVIDED_INTERFACE:
		case AoadlPackage.ATTACHMENT__PROVIDED_ROLE:
			if(attImp.getComponent() != null &&
					attImp.getConnector() != null &&
					attImp.getProvidedInterface() != null &&
					attImp.getProvidedRole() != null &&
					attImp.getComponent().getComponent()!= null && 
					attImp.getConnector().getConnector() != null &&
					attImp.getComponent().getComponent().getClassifier() != null &&   
					attImp.getConnector().getConnector().getClassifier() != null){
				
				EList<ComponentInstance> compClasses = attImp.getComponent().getComponent().getClassifier();
				Interface interClass = attImp.getProvidedInterface().getInterfaceRole().getClassifier();
				ConnectorInstance cnnClasses = attImp.getConnector().getConnector().getClassifier();
				Interface interRoleClass = attImp.getProvidedRole().getInterfaceRole().getClassifier();
				
				
				EList<Attachment> attList = cnnClasses.getOwnerConnectorInstance();
				
				isRigth = false;
				for (int i = 0; i < attList.size(); i++) {
					for (int j = 0; j < compClasses.size(); j++) {
						if(compClasses.get(j).getName().equals(attList.get(i).getComponent().getName()) &&
								attList.get(i).getProvidedInterface() != null &&
								attList.get(i).getProvidedRole() != null &&
								attList.get(i).getProvidedInterface().getInterfaceRole() != null &&
								attList.get(i).getProvidedRole().getInterfaceRole() != null &&
								attList.get(i).getProvidedInterface().getInterfaceRole().getName().equals(interClass.getName())&&
								attList.get(i).getProvidedRole().getInterfaceRole().getName().equals(interRoleClass.getName())){
							
							isRigth = true;
						}
					}
				}
				
				if(!isRigth){
					errors.add("There are inconsistences at Attachment between " + attImp.getComponent().getName() + " and " + attImp.getConnector().getName());
				}
				
			}
			break;

		case AoadlPackage.ATTACHMENT__REQUIRED_INTERFACE:
		case AoadlPackage.ATTACHMENT__REQUIRED_ROLE:
			if(attImp.getComponent() != null &&
					attImp.getConnector() != null &&
					attImp.getRequiredInterface() != null &&
					attImp.getRequiredRole() != null &&
					attImp.getComponent().getComponent()!= null && 
					attImp.getConnector().getConnector() != null &&
					attImp.getComponent().getComponent().getClassifier() != null &&   
					attImp.getConnector().getConnector().getClassifier() != null){
				
				EList<ComponentInstance> compClasses = attImp.getComponent().getComponent().getClassifier();
				Interface interClass = attImp.getRequiredInterface().getInterfaceRole().getClassifier();
				ConnectorInstance cnnClasses = attImp.getConnector().getConnector().getClassifier();
				Interface interRoleClass = attImp.getRequiredRole().getInterfaceRole().getClassifier();
				
				
				//Assertion
				if (cnnClasses.getOwnerConnectorInstance() == null){
					break;
				}
					
					
				EList<Attachment> attList = cnnClasses.getOwnerConnectorInstance();
				
				isRigth = false;
				for (int i = 0; i < attList.size(); i++) {
					for (int j = 0; j < compClasses.size(); j++) {
						if(compClasses.get(j).getName().equals(attList.get(i).getComponent().getName()) &&
								attList.get(i).getRequiredInterface() != null &&
								attList.get(i).getRequiredRole() != null &&
								attList.get(i).getRequiredInterface().getInterfaceRole() != null &&
								attList.get(i).getRequiredRole().getInterfaceRole() != null &&
								attList.get(i).getRequiredInterface().getInterfaceRole().getName().equals(interClass.getName())&&
								attList.get(i).getRequiredRole().getInterfaceRole().getName().equals(interRoleClass.getName())){
							
							isRigth = true;
						}
					}
				}
				
				if(!isRigth){
					errors.add("There are inconsistences at Attachment between " + attImp.getComponent().getName() + " and " + attImp.getConnector().getName());
				}
				
			}
			
			break;
			
		default:
			break;
		}
	
		printErrors(errors);
	}
	
	@Override
	public void notifyChanged(Notification notification) {
		
		if (notification.getFeatureID(Connector.class) == AoadlPackage.CONNECTOR__CLASSIFIER &&
				((ViewerNotification)notification).getElement() instanceof Connector) {
			validateConnector(((ViewerNotification)notification).getElement());
			return;
		}

		if (notification.getFeatureID(Component.class) == AoadlPackage.COMPONENT__CLASSIFIER &&
				((ViewerNotification)notification).getElement() instanceof Component) {
			validateComponent(((ViewerNotification)notification).getElement());
			return;
		}

		if (notification.getFeatureID(Interface.class) == AoadlPackage.INTERFACE__CLASSIFIER &&
				((ViewerNotification)notification).getElement() instanceof Interface) {
			validateInterface(((ViewerNotification)notification).getElement());
			return;
		}
		
		
		if (notification.getFeatureID(Attachment.class) == AoadlPackage.ATTACHMENT__PROVIDED_INTERFACE ||
				notification.getFeatureID(Attachment.class) == AoadlPackage.ATTACHMENT__REQUIRED_INTERFACE ||
				notification.getFeatureID(Attachment.class) == AoadlPackage.ATTACHMENT__PROVIDED_ROLE ||
				notification.getFeatureID(Attachment.class) == AoadlPackage.ATTACHMENT__REQUIRED_ROLE) {
			validateAttachment(((ViewerNotification)notification).getElement(), notification.getFeatureID(Attachment.class));
			return;
		}
	}
}
