package prjaoadlwithcm.wizards;

import java.lang.reflect.InvocationTargetException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;

import org.eclipse.emf.ecore.EValidator;


import org.eclipse.core.resources.IFolder;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.ui.celleditor.ExtendedComboBoxCellEditor;
import org.eclipse.emf.common.util.BasicEList;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.common.util.WrappedException;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.ItemProvider;
import org.eclipse.emf.edit.ui.celleditor.FeatureEditorDialog;
import org.eclipse.emf.edit.ui.provider.AdapterFactoryContentProvider;
import org.eclipse.jface.dialogs.ErrorDialog;
import org.eclipse.jface.operation.IRunnableWithProgress;
import org.eclipse.jface.viewers.IContentProvider;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.wizard.Wizard;
import org.eclipse.ui.INewWizard;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.actions.WorkspaceModifyOperation;
import org.eclipse.uml2.diagram.clazz.part.Messages;
import org.eclipse.uml2.diagram.clazz.part.UMLCreationWizardPage;
import org.eclipse.uml2.diagram.clazz.part.UMLDiagramEditorPlugin;
import org.eclipse.uml2.diagram.clazz.part.UMLDiagramEditorUtil;
import org.eclipse.uml2.diagram.common.part.UMLModelWizardInitialObjectCreationPage;
import org.eclipse.uml2.uml.Package;
import org.eclipse.uml2.uml.Profile;
import org.eclipse.uml2.uml.ProfileApplication;
import org.eclipse.uml2.uml.UMLPackage;
import org.eclipse.uml2.uml.resource.UMLResource;
import org.eclipse.uml2.uml.util.UMLUtil;

import prjaoadlwithcm.editors.UMLwithCMDiagramEditorUtil;


public class UMLModelWizardwithCM extends Wizard implements INewWizard {

		/**
		 * @generated
		 */
		private IWorkbench workbench;

		/**
		 * @generated
		 */
		protected IStructuredSelection selection;

		/**
		 * @generated
		 */
		protected UMLCreationWizardPage diagramModelFilePage;

		/**
		 * @generated
		 */
		protected UMLCreationWizardPage domainModelFilePage;

		/**
		 * @generated
		 */
		private UMLModelWizardPageUML initialObjectCreationPage;

		/**
		 * @generated
		 */
		protected Resource diagram;

		/**
		 * @generated
		 */
		private boolean openNewlyCreatedDiagramEditor = true;

		/**
		 * @generated
		 */
		public IWorkbench getWorkbench() {
			return workbench;
		}

		/**
		 * @generated
		 */
		public IStructuredSelection getSelection() {
			return selection;
		}

		/**
		 * @generated
		 */
		public final Resource getDiagram() {
			return diagram;
		}

		/**
		 * @generated
		 */
		public final boolean isOpenNewlyCreatedDiagramEditor() {
			return openNewlyCreatedDiagramEditor;
		}

		/**
		 * @generated
		 */
		public void setOpenNewlyCreatedDiagramEditor(boolean openNewlyCreatedDiagramEditor) {
			this.openNewlyCreatedDiagramEditor = openNewlyCreatedDiagramEditor;
		}

		/**
		 * @generated
		 */
		public void init(IWorkbench workbench, IStructuredSelection selection) {
			this.workbench = workbench;
			this.selection = selection;
			setWindowTitle(Messages.UMLCreationWizardTitle);
			setDefaultPageImageDescriptor(UMLDiagramEditorPlugin.getBundledImageDescriptor("icons/wizban/NewUMLWizard.gif")); //$NON-NLS-1$
			setNeedsProgressMonitor(true);
		}

		/**
		 * @generated
		 */
		public void addPages() {
			diagramModelFilePage = new UMLCreationWizardPage("DiagramModelFile", getSelection(), "umlclass"); //$NON-NLS-1$ //$NON-NLS-2$
			diagramModelFilePage.setTitle(Messages.UMLCreationWizard_DiagramModelFilePageTitle);
			diagramModelFilePage.setDescription(Messages.UMLCreationWizard_DiagramModelFilePageDescription);
			addPage(diagramModelFilePage);

			domainModelFilePage = new UMLCreationWizardPage("DomainModelFile", getSelection(), "uml"); //$NON-NLS-1$ //$NON-NLS-2$
			domainModelFilePage.setTitle(Messages.UMLCreationWizard_DomainModelFilePageTitle);
			domainModelFilePage.setDescription(Messages.UMLCreationWizard_DomainModelFilePageDescription);
			addPage(domainModelFilePage);

			initialObjectCreationPage = new UMLModelWizardPageUML("InitialObject", UMLPackage.eINSTANCE.getPackage()); //$NON-NLS-1$
			initialObjectCreationPage.setTitle(Messages.UMLCreationWizard_InitialObjectCreationPageTitle);
			initialObjectCreationPage.setDescription(Messages.UMLCreationWizard_InitialObjectCreationPageDescription);
			addPage(initialObjectCreationPage);
			
			//ResourceSet resourceSet = package_.eResource().getResourceSet();
			/*for (URI profileURI : UMLPlugin.getEPackageNsURIToProfileLocationMap().values()) {
				try {
					resourceSet.getResource(profileURI.trimFragment(), true);
				} catch (Exception e) { // ignore
				}
			}*/
			
			/*ItemProvider values;
			IContentProvider contentProvider;
			
			AdapterFactory adapterFactory = new ComposedAdapterFactory(Collections.<AdapterFactory>emptyList());
		    values = new ItemProvider(adapterFactory, Collections.EMPTY_LIST);
		    contentProvider = new AdapterFactoryContentProvider(adapterFactory);
			
		    EList<?> result = new BasicEList<Object>(values.getChildren());

			final FeatureEditorDialog dialog = new FeatureEditorDialog(
				workbenchPart.getSite().getShell(), getLabelProvider(),
				package_, UMLPackage.Literals.PROFILE, Collections.EMPTY_LIST,
				label, choiceOfValues);
			dialog.open();


			for (Object obj : result) {
				pack1.applyProfile((Profile) obj);
			}*/
			
		}
		
		/*private void metho() {
			// TODO Auto-generated method stub

			final org.eclipse.uml2.uml.Package package_ = (org.eclipse.uml2.uml.Package) collection
				.iterator().next();

			final List<Profile> choiceOfValues = new ArrayList<Profile>();

			ResourceSet resourceSet = package_.eResource().getResourceSet();

			for (URI profileURI : UMLPlugin
				.getEPackageNsURIToProfileLocationMap().values()) {

				try {
					resourceSet.getResource(profileURI.trimFragment(), true);
				} catch (Exception e) {
					// ignore
				}
			}

			for (Resource resource : resourceSet.getResources()) {
				TreeIterator<EObject> allContents = resource.getAllContents();

				while (allContents.hasNext()) {

					new UMLSwitch<Object>() {

						@Override
						public Object caseProfile(Profile profile) {

							if (profile.isDefined()) {
								ProfileApplication profileApplication = package_
									.getProfileApplication(profile);

								if (profileApplication == null
									|| profileApplication
										.getAppliedDefinition() != profile
										.getDefinition()) {

									choiceOfValues.add(profile);
								}
							}

							return profile;
						}
					}.doSwitch(allContents.next());
				}
			}

			Collections.<Profile> sort(choiceOfValues,
				new TextComparator<Profile>());

			String label = UMLEditorPlugin.INSTANCE
				.getString("_UI_ApplyProfileActionCommand_label"); //$NON-NLS-1$

			final FeatureEditorDialog dialog = new FeatureEditorDialog(
				workbenchPart.getSite().getShell(), getLabelProvider(),
				package_, UMLPackage.Literals.PROFILE, Collections.EMPTY_LIST,
				label, choiceOfValues);
			dialog.open();

			if (dialog.getReturnCode() == FeatureEditorDialog.OK) {
				editingDomain.getCommandStack().execute(
					new RefreshingChangeCommand(editingDomain, new Runnable() {

						public void run() {

							for (Object result : dialog.getResult()) {
								package_.applyProfile((Profile) result);
							}
						}
					}, label));
			}
		}*/

		/**
		 * @generated
		 */
		public boolean performFinish() {
			IRunnableWithProgress op = new WorkspaceModifyOperation(null) {

				protected void execute(IProgressMonitor monitor) throws CoreException, InterruptedException {
					
					//UMLPackage pack  =  initialObjectCreationPage.getUMLPackage();//UMLPackage.eINSTANCE.getPackage();
					//final Map<String, String> options = new HashMap<String, String>();
					//Collection<org.eclipse.uml2.uml.Package> pack1 = UMLUtil.convertFromEcore(initialObjectCreationPage.getEPackage(), options); 
					//(org.eclipse.uml2.uml.Package)pack.getPackage();

/*					EClass pack = initialObjectCreationPage.getInitialObject();
					
					org.eclipse.uml2.uml.Package pack1 = new org(); 
					
					ResourceSet resourceSet = pack1.iterator().next().eResource().getResourceSet();

					resourceSet.getResource(URI.createURI("/prjaoadlwithcm/profile/CMProfile.uml"), true);
					
					pack1.iterator().next().applyProfile((Profile) resourceSet);*/
					
					
					
					//UMLwithCMDiagramEditorUtil.model = model;
					
					
					//Package pack = UMLwithCMDiagramEditorUtil.getModel();
					
					//System.out.println(model.eResource().getURI().path());
				
					//System.out.println(UMLwithCMDiagramEditorUtil.getModelResource().getURI().path());

					ResourceSet RESOURCE_SET = new ResourceSetImpl();
					Profile profile = null;
					
					IFolder cmFolder = ((IFolder)selection.getFirstElement());

				try {
					URI uri = URI.createURI(cmFolder.getFullPath().append("CMProfile.uml").toPortableString());
					//platform:/resource/prjAOADLCM/CM/default.uml
					Resource resource = RESOURCE_SET.getResource(uri,true);
					profile = (Profile) EcoreUtil.getObjectByType(resource.getContents(), UMLPackage.Literals.PROFILE);					
					
				} catch (WrappedException we) {

					System.out.println(we.getMessage());

					System.exit(1);

				}


				diagram = UMLwithCMDiagramEditorUtil.createDiagramwithCM(diagramModelFilePage.getURI(), domainModelFilePage.getURI(), initialObjectCreationPage.getInitialObject(), initialObjectCreationPage
						.getEncoding(), monitor, profile);
					
					//model.applyProfile(profile);
					
					//ResourceSet resourceSet = diagram.getResourceSet();
					//System.out.println(diagram.getResourceSet().toString());
					//EMFModelFactory.getResourceSet() 
					//System.out.println(this.getClass().getResource("/prjaoadlwithcm/profile/CMProfile.uml").getPath());
					

					
					//UMLResource.UML_PRIMITIVE_TYPES_LIBRARY_URI;
					
					//platform:/plugin/org.eclipse.uml2.diagram.clazz.tests/examples/stereo/SampleProfile.profile.uml
					
					if (isOpenNewlyCreatedDiagramEditor() && diagram != null) {
						try {
							UMLDiagramEditorUtil.openDiagram(diagram);
						} catch (PartInitException e) {
							ErrorDialog.openError(getContainer().getShell(), Messages.UMLCreationWizardOpenEditorError, null, e.getStatus());
						}
					}
					
				}
			};
			try {
				getContainer().run(false, true, op);
			} catch (InterruptedException e) {
				return false;
			} catch (InvocationTargetException e) {
				if (e.getTargetException() instanceof CoreException) {
					ErrorDialog.openError(getContainer().getShell(), Messages.UMLCreationWizardCreationError, null, ((CoreException) e.getTargetException()).getStatus());
				} else {
					UMLDiagramEditorPlugin.getInstance().logError("Error creating diagram", e.getTargetException()); //$NON-NLS-1$
				}
				return false;
			}
			return diagram != null;
		}
		
		
		
	}
